Bug 1481183 - libreswan: libreswan requires both Python 2 and Python 3
Summary: libreswan: libreswan requires both Python 2 and Python 3
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: libreswan   
(Show other bugs)
Version: 27
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Paul Wouters
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: PYTHON3 PY3PATCH-AVAILABLE PYTHON3-PYTHON2
TreeView+ depends on / blocked
 
Reported: 2017-08-14 10:16 UTC by Iryna Shcherbina
Modified: 2018-11-30 18:21 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2018-11-30 17:56:02 UTC
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

Description Iryna Shcherbina 2017-08-14 10:16:47 UTC
The libreswan-3.21-1.fc27 RPM requires both Python 2 and Python 3.

Except in very special circumstances, there is no need for one package
to drag in both Python stacks. Usually, this is a packaging error: for
example, a stray "/usr/bin/python" shebang in a Python 3 package can
introduce a Python 2 dependency.

Please split your package, or remove the stray dependencies.
There is a section on shebangs in the Python RPM Porting Guide [0]
which covers this issue.

It's ok to do this in Rawhide only, however, it would be greatly
appreciated if you could push it to Fedora 26 as well.


If anything is unclear, or if you need any kind of assistance, you can
ask on IRC (#fedora-python on Freenode), or reply here. We'll be happy
to help investigating or fixing this issue!


[0] http://python-rpm-porting.readthedocs.io/en/latest/application-modules.html#are-shebangs-dragging-you-down-to-python-2

Comment 1 Jan Kurik 2017-08-15 07:50:04 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 27 development cycle.
Changing version to '27'.

Comment 2 Jan Beran 2017-08-31 13:19:19 UTC
I created a Pagure PR that fixes the both Python2 and Python 3 requests:

https://src.fedoraproject.org/rpms/libreswan/pull-request/1

May I ask to review and rebuild?

Thanks.

Comment 3 Jan Beran 2017-09-18 13:29:03 UTC
Hello Paul, please, may I ask for your feedback?

Comment 4 Paul Wouters 2017-09-18 20:42:12 UTC
I will add the patch, but I really dislike it. Why is it libreswan's problem?

If we use #!/usr/bin/python then the OS/distro should deal with using whatever default python they use. It should end up with 2 or 3. We don't really care.

Comment 5 Petr Viktorin 2017-09-19 08:45:52 UTC
Fedora's default Python is named /usr/bin/python3, while the unversioned name is tied up in a backwards compatibility quagmire.
The problem is that /usr/bin/python is not used only by the distro, but also by users. Changing it will break everything with that shebang -- except things that are written and tested to work on both versions.

The medium-term plan is to let users configure if "/usr/bin/python" refers to 2 or 3. The short-term plan leading up to that is to change all system packages to specify the version explicitly, so that we don't need to test/support each piece of software with multiple interpreters, and so that an extra Python 2 stack isn't installed if it's not needed.
Fedora packages are something we have some degree of control over, as opposed to user scripts, so that's what we want to change.

Sorry that libreswan ended up at the wrong end of this.

Comment 6 Ben Cotton 2018-11-27 18:26:25 UTC
This message is a reminder that Fedora 27 is nearing its end of life.
On 2018-Nov-30  Fedora will stop maintaining and issuing updates for
Fedora 27. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora  'version' of '27'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 27 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 7 Ben Cotton 2018-11-30 17:56:02 UTC
Fedora 27 changed to end-of-life (EOL) status on 2018-11-30. Fedora 27 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 8 Miro Hrončok 2018-11-30 18:21:22 UTC
$ dnf repoquery --repo=rawhide --requires libreswan | grep py
/usr/bin/python3


Note You need to log in before you can comment on or make changes to this bug.